#################################################
# The Boot CD Menu (v3.0) for CDShell v2.0	#
#						#
# By Ahmad Hisham (Doctor xp)			#
# Copyright (c) 2004 - All rights reserved	#
#################################################

If !compare["$Reset_Menu" ""]; Then GoTo Clear_Dirty_Vars

MenuMode:
	If icompare["$Menu_Mode" "Small"]
		Then Set LargeMenu = 0

		Then Set MenuStep_Min = 1
		Then Set MenuStep_Max = 6

		Then Set WindowMenu_YPos = 2
		Then Set WindowMenu_XPos = 19
		Then Set WindowMenu_XEnd = 19 + 39

		Then Set WindowMoreInfo_YPos = 18
		Then Set WindowMoreInfo_XPos = 2
		Then Set WindowMoreInfo_XEnd = 2 + 75

	If icompare["$Menu_Mode" "Large"]
		Then Set LargeMenu = 1

		Then Set MenuStep_Min = 1
		Then Set MenuStep_Max = 9

		Then Set WindowMenu_YPos = 1
		Then Set WindowMenu_XPos = 19
		Then Set WindowMenu_XEnd = 19 + 39

		Then Set WindowMoreInfo_YPos = 22
		Then Set WindowMoreInfo_XPos = 2
		Then Set WindowMoreInfo_XEnd = 2 + 75

ColorConvert:
	Set C_UB = color[$ColorOf_UpperBar]
	Set C_TB = color[$ColorOf_TitleBar]
	Set C_WB = color[$ColorOf_WindowBody]
	Set C_SD = color[$ColorOf_WindowShadow]
	Set C_HH = color[$ColorOf_HelpHighlight]
	Set C_MO = color[$ColorOf_MenuOption]
	Set C_MH = color[$ColorOf_MenuHighlight]
	Set C_SW = color[$ColorOf_MenuShadow]
	Set C_BG = color[$ColorOf_Background]

	Set C_UB = "\\c($C_UB)"
	Set C_TB = "\\c($C_TB)"
	Set C_WB = "\\c($C_WB)"
	Set C_SD = "\\c($C_SD)"
	Set C_HH = "\\c($C_HH)"
	Set C_MO = "\\c($C_MO)"
	Set C_MH = "\\c($C_MH)"
	Set C_SW = "\\c($C_SW)"
	Set C_BG = "\\c($C_BG)"

StartMenu:
	If $TimeOut > 0; Then Call CountDown
	If $PasswordRequest; Then Call AskPassword
	If $ValidateOptions; Then Call Validate_Options
	If $mouse; Then Set mouseVisible = 1
	Call DrawScreen

StartMenuItem:
	If $OptionDisabled_$MenuStep && $CurrentMenustep == ($MenuStep + 1)
		Then Set CurrentMenustep = $MenuStep
		Then Set MenuStep = $MenuStep - 1
		Then GoTo EndMenuItem
	If $OptionDisabled_$MenuStep
		Then Set CurrentMenustep = $MenuStep
		Then Set MenuStep = $MenuStep + 1
		Then GoTo EndMenuItem
	Set loop = $MenuStep_Min; Set loopEnd = $MenuStep_Max
	loop0:
		Set textCursorX = $WindowMenu_XPos + 2
		Set textCursorY = $WindowMenu_YPos + ($loop * 2)
		If !$OptionDisabled_$loop; Then Print "$C_MO$OptionText_$loop"
	Set loop = $loop + 1
	If $loop > $loopEnd; Then GoTo endloop0
	GoTo loop0
	endloop0:
	Set textCursorX = $WindowMenu_XPos + 2
	Set textCursorY = $WindowMenu_YPos + ($MenuStep * 2)
	Print "$C_MH$OptionText_$MenuStep"

	Set textCursorY = $WindowMoreInfo_YPos + 1
	If $LargeMenu != 1
		Set textCursorX = $WindowMoreInfo_XPos; Print "$C_WB $OptionDesc1_$MenuStep $C_SD\n"
		Then Set textCursorX  =$WindowMoreInfo_XPos; Then Print "$C_WB $OptionDesc2_$MenuStep $C_SD\n"
		Then Set textCursorX  =$WindowMoreInfo_XPos; Then Print "$C_WB $OptionDesc3_$MenuStep $C_SD\n"
		Then Set textCursorX  =$WindowMoreInfo_XPos; Then Print "$C_WB $OptionDesc4_$MenuStep $C_SD\n"
		Then Set textCursorX  =$WindowMoreInfo_XPos; Then Print "$C_WB $OptionDesc5_$MenuStep $C_SD\n"
#
#--- Key Presses Handling
#
MainKey:
	Set CurrentMenustep = $MenuStep
	If $mouse; Then Set mouseVisible = 1
	mGetKey
	#--- Common Keys Handling
	If ($lastKey == key[esc]); Then Call HDDBoot
	If ($lastKey == key[f10]); Then GoTo CmdLine
	If ($lastKey == key[space]); Then GoTo DoAction
	If ($lastKey == key[enter]); Then GoTo DoAction
	#--- Arrows Handling
	If ($lastKey == key[up]); Then Set MenuStep = $MenuStep - 1; Then GoTo EndMenuItem
	If ($lastKey == key[down]); Then Set MenuStep = $MenuStep + 1; Then GoTo EndMenuItem
	If ($lastKey == key[mouse]); Then GoTo GetMouseInput
	GoTo MainKey

#
#--- Mouse Movement Handling
#
GetMouseInput:
	#--- Detect [X] clicks
	If $mouseButtonLeft && $mouseCursorX == ($WindowMenu_XEnd - 2) && $mouseCursorY == $WindowMenu_YPos
		Then GoTo CmdLine
	#--- Detect the XPos of the Mouse
	If $mouseCursorX >= ($WindowMenu_XPos + 2) && $mouseCursorX <= ($WindowMenu_XEnd - 3)
		Then Set MouseInRange_A = 1
		Else Set MouseInRange_A = 0
	If !$MouseInRange_A; Then GoTo endloop0
	Set loop = $MenuStep_Min; Set loopEnd = $MenuStep_Max
	loop1:
		#--- Mouse Hot tracking
		If $MouseInRange_A && $mouseCursorY == ($WindowMenu_YPos + ($loop * 2)) && !$OptionDisabled_$loop && $loop != $MenuStep
			Then Set MenuStep = $loop
			Then  GoTo StartMenuItem
		#--- Handle Mouse Clicks
		If $mouseButtonLeft && $MouseInRange_A && $mouseCursorY == ($WindowMenu_YPos + ($loop * 2)) && !$OptionDisabled_$loop
			Then Set MenuStep = $loop
			Then GoTo DoAction
	Set loop = $loop + 1
	If $loop > $loopEnd; Then GoTo endloop1
	GoTo loop1
	endloop1:
	GoTo MainKey

EndMenuItem:
	If $MenuStep > $MenuStep_Max
		Then Set MenuStep = $MenuStep_Min
	If $MenuStep < $MenuStep_Min
		Then Set MenuStep = $MenuStep_Max
	GoTo StartMenuItem

DoAction:
	If !compare["$ActionMacro_$MenuStep" ""]
		Then Call $ActionMacro_$MenuStep
	If !compare["$ActionSilent_$MenuStep" "1"]
		Then Set textColor = 0x0f
		Then Clear
		Then Print "Selected Option : $OptionText_$MenuStep\n"
	Set loop = 1; Set loopEnd = 3
	loop5:
		$ActionCmd$(loop)_$MenuStep
	Set loop = $loop + 1
	If $loop > $loopEnd; Then GoTo endloop5
	GoTo loop5
	endloop5:
	Call DrawScreen
	GoTo StartMenuItem

#
#--- FUNCTION : End the Script and show the CDShell Console
#
CmdLine:
	Set textColor = 0x0f
	Set boldColor = 0x0e
	Clear
	About
	Print "\n\n"
	Print "Script Copyright (C) 2004 Ahmad Hisham.\n"
	Print "Find the latest release at \cXXhttp://www.911cd.net\cxx.\n"
	End
#
#--- FUNCTION : Draw the Screen Contents
#
DrawScreen:
	#--- Clear the screen and Set the background
	Show console
	Set boldColor = color[$ColorOf_Background]
	Set textColor = color[$ColorOf_Background]
	Clear

	#--- Drawing the Screen top Banner
	If $LargeMenu != 1
		Then Set textCursorX = 0
		Then Set textCursorY = 0
		Then Print "$C_UB $Banner_Text "

	#--- Drawing the Main Window
	Set textCursorX = $WindowMenu_XPos
	Set textCursorY = $WindowMenu_YPos
	Print "$C_TB $TitleBar_Text $C_SD\n"
	Set textCursorX = $WindowMenu_XPos
	Print "$C_WB                                        $C_SD\n"
	Set loop = $MenuStep_Min; Set loopEnd = $MenuStep_Max
	loop2:
		If !$OptionDisabled_$loop
			Then Set textCursorX = $WindowMenu_XPos; Then Print "$C_WB  $C_MO$(OptionText_$loop)$C_SW$C_WB  $C_SD\n"
			Then Set textCursorX = $WindowMenu_XPos; Then Print "$C_WB   $C_SW$C_WB  $C_SD\n"
			Else Set textCursorX = $WindowMenu_XPos; Else Print "$C_WB                                        $C_SD\n"
			Else Set textCursorX = $WindowMenu_XPos; Else Print "$C_WB                                        $C_SD\n"
	Set loop = $loop + 1
	If $loop > $loopEnd; Then GoTo endloop2
	GoTo loop2
	endloop2:
	Set textCursorX = $WindowMenu_XPos
	Print "$C_SD \n"

	#--- Drawing the MoreInfo Window
	Set textCursorX = $WindowMoreInfo_XPos
	Set textCursorY = $WindowMoreInfo_YPos
	Print "$C_TB More info:                                                                $C_SD\n"
	If $LargeMenu != 1
		Set FillSpace = "                                                                         "
		Set textCursorX = $WindowMoreInfo_XPos; Print "$C_WB $FillSpace $C_SD\n"
		Then Set textCursorX = $WindowMoreInfo_XPos; Then Print "$C_WB $FillSpace $C_SD\n"
		Then Set textCursorX = $WindowMoreInfo_XPos; Then Print "$C_WB $FillSpace $C_SD\n"
		Then Set textCursorX = $WindowMoreInfo_XPos; Then Print "$C_WB $FillSpace $C_SD\n"
		Then Set textCursorX = $WindowMoreInfo_XPos; Then Print "$C_WB $FillSpace $C_SD\n"
		Set textCursorX = $WindowMoreInfo_XPos; Print "$C_SD "
		Set Spaces73 = ""

	#--- Finishing Function
	Set boldColor = color[$ColorOf_HelpHighlight]
	Set textColor = color[$ColorOf_WindowBody]
	Return

ShowWinKey:
	Set textCursorX = 0
	Set textCursorY = 6
	Print c "$C_TB The Windows xp Pro Product Key             [X] $C_SD\n"
	Print c "$C_WB                                                $C_SD\n"
	Print c "$C_WB         Use the Following Product Key          $C_SD\n"
	Print c "$C_WB                                                $C_SD\n"
	Print c "$C_WB     $C_MO$WinKey_Part1$C_SW  $C_MO$WinKey_Part2$C_SW  $C_MO$WinKey_Part3$C_SW  $C_MO$WinKey_Part4$C_SW  $C_MO$WinKey_Part5$C_SW     $C_SD\n"
	Print c "$C_WB      $C_SW                 $C_SD\n"
	Print c "$C_WB                                                $C_SD\n"
	Print c "$C_WB Please write the Key down on a Piece of Paper, $C_SD\n"
	Print c "$C_WB You will need it to complete the Setup.        $C_SD\n"
	Print c "$C_WB                                                $C_SD\n"
	Print c "$C_SD \n"
	Set textCursorX = 0
	Set textCursorY = 24
	GetKey
	If $lastKey == key[esc]
		Then Call DrawScreen
		Then GoTo StartMenu
	Return

HDDBoot:
	Set textColor = color[$ColorOf_Background]
	Clear
	If bootCheck[0x80] == 3; Then Boot 0x80
	Set textCursorX = 0
	Set textCursorY = 8
	Print c "$C_TB Boot from HDD0 failed                       [X] $C_SD\n"
	Print c "$C_WB                                                 $C_SD\n"
	Print c "$C_WB          Booting from hard disk failed          $C_SD\n"
	Print c "$C_WB    Your Hard Disk seems uncapable of booting    $C_SD\n"
	Print c "$C_WB     You will be redirected to the Main Menu     $C_SD\n"
	Print c "$C_WB                                                 $C_SD\n"
	Print c "$C_SD \n"
	GetKey 5
	Call DrawScreen
	Return

AskPassword:
	If compare["$TempPass" "$PasswordString"]; Then Return
	Set TempPass  = ""
	Set CharCount = 0
	Set Pass_XPos = 31
	Set Pass_YPos = 13
	Set textColor = color[$ColorOf_Background]
	Clear
	Set textCursorX = 0
	Set textCursorY = 8
	Print c "$C_TB Enter Access Password                       [X] $C_SD\n"
	Print c "$C_WB                                                 $C_SD\n"
	Print c "$C_WB    You need to enter your Password in order     $C_SD\n"
	Print c "$C_WB    to access the boot options:                  $C_SD\n"
	Print c "$C_WB                                                 $C_SD\n"
	Print c "$C_WB    PASSWORD :  $C_MO                             $C_WB    $C_SD\n"
	Print c "$C_WB                 $BadPassMsg                $C_SD\n"
	Print c "$C_SD \n"

	GetPassChar:
		GetKey
		If $lastKey == key[enter]; Then GoTo PassEntered
		Set TempPass = "$(TempPass)$lastChar"
		Set CharCount = $CharCount + 1
		If $CharCount >= 15 ;Then GoTo NoCharPrint
		Set textCursorX = $Pass_XPos + $CharCount
		Set textCursorY = $Pass_YPos
		Print "$C_MO* "
		NoCharPrint:
		GoTo GetPassChar

	PassEntered:
		Set MD5 = "$TempPass"
		Set TempPass = "$MD5"
		If compare["$TempPass" "$PasswordString"]; Then Return

		Set BadPass = $BadPass + 1
		If compare["$BadPass" "3"]; Then GoTo LockBadPass
		Set BadPassMsg = "Invalid Password"
		GoTo AskPassword

	LockBadPass:
		Set textCursorX = 0
		Set textCursorY = 8
		Print c "$C_TB CD is locked Out                            [X] $C_SD\n"
		Print c "$C_WB                                                 $C_SD\n"
		Print c "$C_WB                                                 $C_SD\n"
		Print c "$C_WB            A C C E S S   D E N I E D            $C_SD\n"
		Print c "$C_WB         I N V A L I D   P A S S W O R D         $C_SD\n"
		Print c "$C_WB                                                 $C_SD\n"
		Print c "$C_WB                                                 $C_SD\n"
		Print c "$C_SD \n"
		GetKey 30
		GoTo LockBadPass

Validate_Options:
	Set loop = $MenuStep_Min; Set loopEnd = $MenuStep_Max
	loop4:
		If !file[$ActionFile_$loop] && !compare["$ActionValid_$loop" "1"]; Then Set OptionDisabled_$loop=1
	Set loop = $loop + 1
	If $loop > $loopEnd; Then GoTo endloop4
	GoTo loop4
	endloop4:
	Set ValidateOptions = 0
	Return

CountDown:
	If defined[CounterDisabled]; Then Return; Else Set CounterDisabled = 1
	If $TimerPopup == 1; Then Call DrawCountDown_Big
	If $TimerPopup == 0; Then Call DrawCountDown_Small
	GoTo CounterDescent

	DrawCountDown_Big:
		Set Timer_XPos = 57
		Set Timer_YPos = 8
		Set boldColor = color[$ColorOf_Background]
		Set textColor = color[$ColorOf_Background]
		Clear
		Set textCursorY = $Timer_YPos - 2
		Print c "$C_TB Boot from the CD                         [X] $C_SD\n"
		Print c "$C_WB                                              $C_SD\n"
		Print c "$C_WB   Press any key to boot from the CD ...      $C_SD\n"
		Print c "$C_WB           (Booting from Hard Disk)           $C_SD\n"
		Print c "$C_WB                                              $C_SD\n"
		If $TimerPopup == 1; Then Print c "$C_SD $C_SW$C_SD\n"
		If $TimerPopup == 2; Then Print c "$C_SD \n"
		Set boldColor = color[$ColorOf_HelpHighlight]
		Set textColor = color[$ColorOf_WindowBody]
		Return

	DrawCountDown_Small:
		Set Timer_XPos = 41
		Set Timer_YPos = $WindowMoreInfo_YPos + 1
		Call DrawScreen
		Set textCursorX=$Timer_XPos - 39
		Set textCursorY=$Timer_YPos
		Print "$C_WB Press any key to boot from the CD ...     (Booting from HDD)"
		Return

	Counter:
		mGetKey 1 GoTo CounterDescent
		If ($lastKey == key[f10]); Then GoTo CmdLine
		If ($lastKey == key[esc]); Then Call HDDBoot; Then Return
		Call DrawScreen
		Return
	CounterDescent:
		Set textCursorX = $Timer_XPos
		Set textCursorY = $Timer_YPos
		If $TimeOut >= 100; Then Print "\cXX$TimeOut\cxx"
		If $TimeOut <= 99 ; Then If $TimeOut >=10; Then Print " \cXX$TimeOut\cxx"
		If $TimeOut <= 9  ; Then Print "  \cXX$TimeOut\cxx"
		If $TimeOut == 0  ; Then Call HDDBoot; Return
		Set TimeOut = $TimeOut - 1
		GoTo Counter


Clear_Dirty_Vars:
	Set Spaces35 = "                                   "
	Set Spaces38 = "$Spaces35   "
	Set Spaces73 = "$Spaces38$Spaces35"
	Set Spaces78 = "$Spaces73     "
	Set Banner_Text = "$Spaces78"
	Set TitleBar_Text = "$Spaces38"
	Set WinKey_Part1 = "     "
	Set WinKey_Part2 = "     "
	Set WinKey_Part3 = "     "
	Set WinKey_Part4 = "     "
	Set WinKey_Part5 = "     "
	Set PasswordRequest = 0
	Set PasswordString = ""
	Set BadPassMsg = "                "
	Set BadPass = 0
	Set CharCount = 0
	Set TimerPopup = 0
	Set TimeOut = 0
	Set CurrentMenustep = 0
	Set MenuStep = 1
	Set ValidateOptions = 0

	Set loop = 1; Set loopEnd = 9
	loop3:
		Set OptionText_$loop = "$Spaces35"
		Set OptionDisabled_$loop = 0
		Set ActionCmd1_$loop = ""
		Set ActionCmd2_$loop = ""
		Set ActionCmd3_$loop = ""
		Set ActionMacro_$loop = ""
		Set ActionSilent_$loop = 0
		Set OptionDesc1_$loop = "$Spaces73"
		Set OptionDesc2_$loop = "$Spaces73"
		Set OptionDesc3_$loop = "$Spaces73"
		Set OptionDesc4_$loop = "$Spaces73"
		Set OptionDesc5_$loop = "$Spaces73"
	Set loop = $loop + 1
	If $loop > $loopEnd; Then GoTo endloop3
	GoTo loop3
	endloop3:
	Set Spaces78 = ""; Set Spaces73 = ""; Set Spaces38 = ""; Set Spaces35 = ""

	Set Return_Menu = "$Reset_Menu"
	Set Reset_Menu = "OK"
	Script $Return_Menu

# EOF